//+------------------------------------------------------------------+
//|                                                      ProjectName |
//|                                      Copyright 2012, CompanyName |
//|                                       http://www.companyname.net |
//+------------------------------------------------------------------+
#property strict

//--- input parameters
extern int Sys=0;
int       sys;
double    opb;
double    ops;
double    cb;
double    cs;
double    lot;
double    next_order;
int       i=0;
int       x;
double    max;
double    min;
int       ticket;
int       tip;
int       count;
bool      res;
double    bal;
double    sl;
datetime  d;
double    N;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
   sys=(Sys<0)?0:Sys;
   bal=AccountBalance();
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+

int start()
  {
//----
   Comment("\nsys="+IntegerToString(sys));
   if(sys==1)
     {
      opb=High[iHighest(NULL,0,MODE_HIGH,55,1)];
      ops=Low[iLowest(NULL,0,MODE_LOW,55,1)];
      cs=High[iHighest(NULL,0,MODE_HIGH,20,1)];
      cb=Low[iLowest(NULL,0,MODE_LOW,20,1)];
      N=iATR(NULL,0,55,0);
      Print("sys   1 ... : "+IntegerToString(sys));
     }
   else
     {
      //,   20-  
      opb=High[iHighest(NULL,0,MODE_HIGH,20,1)];
      ops=Low[iLowest(NULL,0,MODE_LOW,20,1)];
      //,   10-  
      cs=High[iHighest(NULL,0,MODE_HIGH,10,1)];
      cb=Low[iLowest(NULL,0,MODE_LOW,10,1)];
      //,   55-  */
      N=iATR(NULL,0,20,0);
      Print("sys    1 ... : "+IntegerToString(sys));
     }

   lot=NormalizeDouble((0.01*AccountBalance())/100*(N*Point),2);
   if(Ask>opb || Bid<ops)
     {
      count=0;
      for(i=1; i<=OrdersTotal(); i++)
         if(OrderSelect(i-1,SELECT_BY_POS)==true)
           {
            if(Symbol()==OrderSymbol())
              {count++;}
           }
      if(AccountBalance()>bal)
         if(sys==0 || sys==2)
           {
            if(tip==0)opb=High[iHighest(NULL,0,MODE_HIGH,55,1)];
            else ops=Low[iLowest(NULL,0,MODE_LOW,55,1)];
           }
      if(count==0)
        {
         if(Ask>opb)
           {
            ticket=OrderSend(Symbol(),OP_BUY,lot,Ask,300,Bid-2*N,0,"My order #",16384,0,Green);
            tip=0;
            next_order=Ask+0.5*N;
            if(ticket<0)
              {
               Print("   #",GetLastError());
               return(0);
              }
            else bal=AccountBalance();
           }
         if(Bid<ops)
           {
            ticket=OrderSend(Symbol(),OP_SELL,lot,Bid,300,Ask+2*N,0,"My order #",16384,0,Green);
            tip=1;
            next_order=Bid-0.5*N;
            if(ticket<0)
              {
               Print("   #",GetLastError());
               return(0);
              }
            else bal=AccountBalance();
           }
        }
      else
      if(count<4 && count>0)
        {
         if(Ask>opb && Ask>=next_order)
           {
            for(i=1; i<=OrdersTotal(); i++)
               if(OrderSelect(i-1,SELECT_BY_POS)==true)
                 {
                  if(Symbol()==OrderSymbol())
                    {
                     res=OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(Bid-2*N,Digits),OrderTakeProfit(),0,Blue);
                     if(!res)
                        Print("  .  =",GetLastError());
                    }
                 }
            sl=Bid-2*N;
            ticket=OrderSend(Symbol(),OP_BUY,lot,Ask,300,Bid-2*N,0,"My order #",16384,0,Green);
            if(ticket<0)
              {
               Print("   #",GetLastError());
               return(0);
              }
            else bal=AccountBalance();
            next_order=Ask+0.5*N;
            d=iTime(NULL,PERIOD_D1,1);
           }
         if(Bid<ops && Bid<=next_order)
           {
            for(i=1; i<=OrdersTotal(); i++)
               if(OrderSelect(i-1,SELECT_BY_POS)==true)
                 {
                  if(Symbol()==OrderSymbol())
                    {
                     res=OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(Ask+2*N,Digits),OrderTakeProfit(),0,Blue);
                     if(!res)
                        Print("  .  =",GetLastError());
                    }
                 }
            sl=Ask+2*N;
            ticket=OrderSend(Symbol(),OP_SELL,lot,Bid,300,Ask+2*N,0,"My order #",16384,0,Green);
            if(ticket<0)
              {
               Print("OrderSend failed with error #",GetLastError());
               return(0);
              }
            else bal=AccountBalance();
            next_order=Bid-0.5*N;
            d=iTime(NULL,PERIOD_D1,1);
           }
        }
     }
   if(Bid<cb && tip==0)
     {
      for(i=1; i<=OrdersTotal(); i++)
         if(OrderSelect(i-1,SELECT_BY_POS)==true)
           {
            if(Symbol()==OrderSymbol())
              {
               res=OrderClose(OrderTicket(),OrderLots(),Bid,100,Blue);
               if(!res)
                  Print("  .  =",GetLastError());
              }
           }
     }
   if(Ask>cs && tip==1)
     {
      for(i=1; i<=OrdersTotal(); i++)
         if(OrderSelect(i-1,SELECT_BY_POS)==true)
           {
            if(Symbol()==OrderSymbol())
              {
               res=OrderClose(OrderTicket(),OrderLots(),Ask,100,Blue);
               if(!res)
                  Print("  .  =",GetLastError());
              }
           }
     }
   if(sys==2 && count==4)
     {
      if(d<iTime(NULL,PERIOD_D1,0))
        {
         d=iTime(NULL,PERIOD_D1,1);
         if(Bid>next_order && tip==0 && sl<NormalizeDouble(iClose(NULL,PERIOD_D1,1)-2*N,Digits))
           {
            for(i=1; i<=OrdersTotal(); i++)
               if(OrderSelect(i-1,SELECT_BY_POS)==true)
                 {
                  if(Symbol()==OrderSymbol())
                    {
                     res=OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(iClose(NULL,PERIOD_D1,1)-2*N,Digits),OrderTakeProfit(),0,Blue);
                     if(!res)
                        Print("  .  =",GetLastError());
                    }
                 }
            sl=NormalizeDouble(iClose(NULL,PERIOD_D1,1)-2*N,Digits);
           }
         if(Ask<next_order && tip==1 && sl>NormalizeDouble(iClose(NULL,PERIOD_D1,1)+2*N,Digits))
           {
            for(i=1; i<=OrdersTotal(); i++)
               if(OrderSelect(i-1,SELECT_BY_POS)==true)
                 {
                  if(Symbol()==OrderSymbol())
                    {
                     res=OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(iClose(NULL,PERIOD_D1,1)+2*N,Digits),OrderTakeProfit(),0,Blue);
                     if(!res)
                        Print("  .  =",GetLastError());
                    }
                 }
            sl=NormalizeDouble(iClose(NULL,PERIOD_D1,1)+2*N,Digits);
           }
        }
     }
//----
   return(0);
  }
//+------------------------------------------------------------------+
